#ifndef VolumeSpiderDialog_H
#define VolumeSpiderDialog_H

#include <QtWidgets/QMainWindow>
#include <QDragEnterEvent>
#include <qmimedata.h>
#include <qfiledialog.h>
#include <qinputdialog.h>
#include "ui_qtMainDialog.h"

//simulation parameters
#include "microscope.h"
extern microscopeStruct* SCOPE;

//#include "fileout.h"
//extern fileoutStruct gFileOut;
#include "rts/visualization/colormap.h"


class qtMainDialog : public QMainWindow
{
Q_OBJECT

public:
qtMainDialog(QWidget *parent = 0, Qt::WindowFlags flags = 0);
~qtMainDialog();

void closeEvent(QCloseEvent *event);
bool updating;

QString outfile;

void refreshUI()
{
	updating = false;
}

void populateUi();
void renderImage();
void positionImage();

private:
Ui::qtMainDialogUI ui;

public slots:

/*************
Buttons
*************/
void on_btnRender_pressed()
{
    renderImage();
}
void on_btnClearDetector_pressed()
{
    SCOPE->clearDetector();
}

/***************
Spinners
***************/
void on_spinCx_valueChanged(double d)
{
    positionImage();
}
void on_spinCy_valueChanged(double d)
{
    positionImage();
}
void on_spinCz_valueChanged(double d)
{
    positionImage();
}
void on_spinNx_valueChanged(double d)
{
    positionImage();
}
void on_spinNy_valueChanged(double d)
{
    positionImage();
}
void on_spinNz_valueChanged(double d)
{
    positionImage();
}
void on_spinS_valueChanged(double d)
{
    positionImage();
}
void on_spinTheta_valueChanged(double d)
{
    positionImage();
}


};

#endif // INTERACTIVEMIE_H
